#!/usr/bin/env python
# coding: utf-8

# # 导入sqlserver

# In[77]:


import pandas as pd
import os
import numpy as np
from sqlalchemy import create_engine
from sqlalchemy.types import CHAR, INT, VARCHAR, FLOAT, TEXT
import time

filelist = os.listdir('D:/数据/天软基本面数据/46.合并利润分配表')
engine = create_engine('mssql+pymssql://sa:admin@192.168.1.128/test')
conn = engine.connect()
for i in range(2451, 2452):
    file = filelist[i]
    data = pd.read_csv('D:/数据/天软基本面数据/46.合并利润分配表/' + file)
    data['备注'] = data['备注'].astype(str) # 强制转换备注列为str格式
#     data['主营业务利润'] = data['主营业务利润'].astype(np.float64)
#     data['预警详情'] = data['预警详情'].astype(str)
    title_list = pd.read_excel('D:/数据/天软基本面数据/wind-天软字段匹配/天软中英文字段对照表.xlsx',
                              '合并利润分配表')
    eng_name = title_list['英文名']
    dtype = title_list['数据类型']
    data.columns = eng_name # 替换data字段名为英文字段
    dtype_dict = {'INT': INT(),
                'CHAR(8)': CHAR(8),
                'VARCHAR(20)': VARCHAR(20),
                'TEXT': TEXT(),
                'FLOAT': FLOAT()} # 原表数据类型和sql数据类型转换映射
    dtype_list = dtype.map(dtype_dict)
    dtype_list = pd.concat([eng_name, dtype_list], axis=1)
    dtype_list = dtype_list.set_index('英文名').to_dict()['数据类型']
    data.to_sql('CONSOLIDATED_INCOMESTATEMENT', 
                 conn, 
                 index=False, 
                 if_exists='append', 
                 dtype=dtype_list)
    time.sleep(0.1)
conn.close()
engine.dispose()


# # 转换列属性

# In[ ]:


import pymssql
conn = pymssql.connect('192.168.1.128', 'sa', 'admin', "test") #tempdb is a database
cursor = conn.cursor()
sqls = ['ALTER TABLE EARNINGS_PREANNOUNCEMENT ALTER COLUMN StockID CHAR(8) NOT NULL',
       'ALTER TABLE EARNINGS_PREANNOUNCEMENT ALTER COLUMN S_PROFITNOTICE_PERIOD INT NOT NULL',
#        'ALTER TABLE PRELIMINARY_EARNING_EST ALTER COLUMN REPORT_DATE INT NOT NULL',
       'ALTER TABLE EARNINGS_PREANNOUNCEMENT ALTER COLUMN S_PROFITNOTICE_DATE INT NOT NULL',
       '''ALTER TABLE EARNINGS_PREANNOUNCEMENT ADD CONSTRAINT STOCK_EP_ID PRIMARY KEY
       (StockID,S_PROFITNOTICE_PERIOD,S_PROFITNOTICE_DATE)''',
       'CREATE NONCLUSTERED INDEX STOCK_INTID ON EARNINGS_PREANNOUNCEMENT (StockID_INT)']
for sql in sqls:
    cursor.execute(sql) # create a new sheet
conn.commit()
conn.close()


# In[60]:


conn = pymssql.connect('192.168.1.128', 'sa', 'admin', "test") #tempdb is a database
cursor = conn.cursor()
sql1 = '''
sp_rename 'DIVIDEND_ANNOUNCEMENT.REPORT_PERIOD', 'ReportPeriod', 'column'
'''
# sql2 = '''
# sp_rename 'DIVIDEND_ANNOUNCEMENT.S_PROFITNOTICE_DATE', 'AppearAtDate', 'column'
# '''
sql3 = '''
drop index STOCK_INTID on DIVIDEND_ANNOUNCEMENT 
'''
sql4 = '''
alter table DIVIDEND_ANNOUNCEMENT drop column StockID_INT
'''
cursor.execute(sql1)
# cursor.execute(sql2)
cursor.execute(sql3)
cursor.execute(sql4)
conn.commit()
conn.close()


# # 创建view

# In[184]:


conn = pymssql.connect('192.168.1.128', 'sa', 'admin', "test") #tempdb is a database
cursor = conn.cursor()
# sql = '''
# CREATE VIEW LAYER1 AS
# SELECT A.StockID, A.REPORT_PERIOD, A.ACTUAL_ANN_DT FROM
# (
# SELECT *, ROW_NUMBER() OVER(PARTITION BY StockID, REPORT_PERIOD order by StockID, REPORT_PERIOD) 
# AS RowNumber FROM FINCOMP_CASHFLOWSTATEMENT
# )A
# WHERE A.RowNumber=1
# '''
sql = '''
CREATE VIEW DIVMeta AS
SELECT StockID,
RIGHT(StockID,6) + '.' + LEFT(StockID,2) AS WIND_CODE, 
CONVERT(INT, RIGHT(StockID, 6)) AS IntCode,
ReportPeriod FROM DIVIDEND_ANNOUNCEMENT
'''
cursor.execute(sql)
conn.commit()
conn.close()


# In[185]:


import re
wind_index = pd.read_excel('D:/数据/天软基本面数据/wind-天软字段匹配/已匹配索引总表.xlsx',
                              '分红送股')
view_column = list(wind_index['字段名']) # wind英文字段, AS后字段
view_joinindex = list(wind_index['天软字段']) # 天软对应wind中文字段和计算字段
ts_index = pd.read_excel('D:/数据/天软基本面数据/wind-天软字段匹配/天软中英文字段对照表.xlsx',
                              '分红送股')
sql_matching = []
for i in range(len(view_column)):
    if 'exp' in view_joinindex[i]:
        expresion = view_joinindex[i]
        ts_columns = re.split('\$| ', expresion)
        ts_columns = [col for col in ts_columns if u'\u4e00' <= col <= u'\u9fff'] #解析出所有中文字段
        for col in ts_columns:
            expresion = expresion.replace(col, 'B.' + ts_index.loc[ts_index['天软字段'] == col, '英文名'].values[0])
        expresion = expresion.replace('exp:', '')
        expresion = expresion.replace('$', '')
        sql_matching.append(expresion)
        sql_matching.append(' AS ' + view_column[i] + ',')
    else:
        sql_matching.append('B.' + ts_index.loc[ts_index['天软字段'] == view_joinindex[i], '英文名'].values[0] + 
                            ' AS ' + view_column[i] + ',')
sql_matching[-1] = sql_matching[-1].replace(',', '')
sql_matching = ''.join(sql_matching)


# In[186]:


conn = pymssql.connect('192.168.1.128', 'sa', 'admin', "test") #tempdb is a database
cursor = conn.cursor()
sql = 'CREATE VIEW DIVWind AS ' +         'SELECT A.WIND_CODE, A.IntCode, A.ReportPeriod, ' +         sql_matching + ' FROM DIVMeta A LEFT JOIN DIVIDEND_ANNOUNCEMENT B ON ' +         'A.StockID = B.StockID AND A.ReportPeriod = B.ReportPeriod'
cursor.execute(sql)
conn.commit()
conn.close()


# # 删除view

# In[134]:


import pymssql
conn = pymssql.connect('192.168.1.128', 'sa', 'admin', "test") #tempdb is a database
cursor = conn.cursor()
# sql = '''
# SELECT RIGHT(StockID,6) + '.' + LEFT(StockID,2) FROM CONSOLIDATED_BALANCESHEET
# '''
sql = '''
IF EXISTS(SELECT * FROM SYS.VIEWS WHERE NAME='CBSBeforeAdj')
DROP VIEW CBSBeforeAdj
'''
cursor.execute(sql)
conn.commit()
conn.close()

