import os.path

import pandas as pd
from tqdm import tqdm

from tsl import *
from market import *
from config import *

def merge_k_daily():
    
    shard_dump_folder = '{}/行情数据/日K线/shards/'.format(TINYSOFT_DATA_PATH)
    merged_dump_folder = '{}/行情数据/日K线/merged/'.format(TINYSOFT_DATA_PATH)

    DLMarket.k_daily_data_shards

    with tsl() as t:
       stock_list = t.get_stock_list()

    with tqdm(stock_list) as pbar:
        
        for stock_id in pbar:
            pbar.set_description('正在处理', stock_id)

            df_list = []
            for date_range in Market.k_daily_data_shards:
                
                start_date, end_date = \
                        date_range[0], date_range[1]
                shard_name = str(start_date) + '-' + str(end_date)
                
                load_path = '{}/{}/{}.csv'.format(
                    shard_dump_folder,
                    shard_name,
                    stock_id
                )

                pbar.set_description('正在载入', load_path)
                if not os.path.exists(load_path):
                    continue

                _df = pd.read_csv(load_path)

                if len(_df) > 0:
                    df_list.append(_df)

            pbar.set_description('正在拼接', stock_id)
            if len(df_list) > 0:
                df = pd.concat(df_list, axis=0)
                df.set_index(['StockID', 'date'], inplace=True)

                dump_path = '{}/{}.csv'.format(
                    merged_dump_folder,
                    stock_id
                )
                df.to_csv(dump_path)



if __name__ == '__main__':
    merge_k_daily()
